--Code is released under Disco licence:
--You are free to do whatever you want as long as you dance DISCO before that

--Art assets and sounds aren't mine. They are created by captaincrunch80, and can be found on opengameart.org. Public domain

function love.load()
--load resources
	background = love.graphics.newImage("back_g.png")
	paddleL = love.graphics.newImage("player_g.png")
	paddleR = love.graphics.newImage("player_g.png")
	ball = love.graphics.newImage("ball_g.png")
	scoreSound = love.audio.newSource("peeeeeep.ogg", "static")
	wallSound = love.audio.newSource("plop.ogg", "static")
	paddleSound = love.audio.newSource("beeep.ogg", "static")
	font = love.graphics.newFont(36)
	love.graphics.setFont(font)
--set up starting values	
	ballX = 240
	ballY = 160
	paddleLX = 50
	paddleLY = 160
	paddleRX = 430
	paddleRY = 160
	scoreL = 0
	scoreR = 0
	speed = 200
--set up starting ball angle	
	ballDirection = math.random(360)
	while (ballDirection == 90 or ballDirection == 270) do
		ballDirection = math.random(360)
	end
	
end
	
function love.update(dt)
--controls L
	if love.keyboard.isDown("w") then
		paddleLY = paddleLY - speed * dt
	elseif love.keyboard.isDown("s") then
		paddleLY = paddleLY + speed * dt
	end
--paddle limits	L
	if paddleLY < 30 then
		paddleLY = 30
	elseif paddleLY > 290 then
		paddleLY = 290
	end
	
--same for right		
	if love.keyboard.isDown("up") then
		paddleRY = paddleRY - speed * dt
	elseif love.keyboard.isDown("down") then
		paddleRY = paddleRY + speed * dt
	end
		
	if paddleRY < 30 then
		paddleRY = 30
	elseif paddleRY > 290 then
		paddleRY = 290
	end
	

	
--ball wall bounce: a bit of randomness	
	if ballY < 8 then
		ballY = 10
		ballDirection =  -ballDirection + math.random(11) - 5
		love.audio.play(wallSound)
	elseif ballY > 312 then
		ballY = 310
		ballDirection =  -ballDirection + math.random(11) - 5
		love.audio.play(wallSound)
	end
--paddle bounce
	if (ballX < 65 and ballX > 60 and ballY < (paddleLY + 38) and ballY > (paddleLY - 38)) then
		ballDirection = ballDirection + 180
		ballX = 66
		love.audio.play(paddleSound)
	end
	
	if (ballX > 415 and ballX < 420 and ballY < (paddleRY + 38) and ballY > (paddleRY - 38)) then
		ballDirection = ballDirection + 180
		ballX = 411
		love.audio.play(paddleSound)
	end
--keep direction in range
	if ballDirection > 360 then
		 ballDirection = ballDirection - 360
	elseif ballDirection < 0 then
		 ballDirection = ballDirection + 360
	end
--a bit of trigonometry calculations
	ballX = ballX + speed * math.cos(ballDirection/(2*math.pi))*dt
	ballY = ballY + speed * math.sin(ballDirection/(2*math.pi))*dt
--scoring	
	if ballX > 472 then
		scoreL = scoreL + 1
		ballX = 240
		ballY = 160
		love.audio.play(scoreSound)
		ballDirection = math.random(360)
		while (ballDirection == 90 or ballDirection == 270) do
			ballDirection = math.random(360)
		end
	end
	
	if ballX < 8 then
		scoreR = scoreR + 1
		ballX = 240
		ballY = 160
		love.audio.play(scoreSound)
		ballDirection = math.random(360)
		while (ballDirection == 90 or ballDirection == 270) do
			ballDirection = math.random(360)
		end
	end
	
end
	
function love.draw()
--DRAW, PARTNER
	love.graphics.draw(background,0,0)
	love.graphics.draw(paddleL,paddleLX, paddleLY,0,1,1,7,30)
	love.graphics.draw(paddleR,paddleRX, paddleRY,0,1,1,7,30)
	love.graphics.draw(ball, ballX, ballY,0,1,1,8,8)
	love.graphics.print(scoreL, 200, 20)
	love.graphics.print(scoreR, 262, 20)
	
end